SetMowerOptionsEvent = {};
SetMowerOptionsEvent_mt = Class(SetMowerOptionsEvent, Event);

InitEventClass(SetMowerOptionsEvent, "SetMowerOptionsEvent");

function SetMowerOptionsEvent:emptyNew()
    local self = Event:new(SetMowerOptionsEvent_mt);
    self.className = "SetMowerOptionsEvent";
    return self;
end;

function SetMowerOptionsEvent:new(object, setUnfold, setDown, setTurnedOn, setSwathOn)
    local self = SetMowerOptionsEvent:emptyNew()
    self.object = object;
	self.setUnfold = setUnfold;
	self.setDown = setDown;
	self.setTurnedOn = setTurnedOn;
	self.setSwathOn = setSwathOn;
    return self;
end;

function SetMowerOptionsEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.setUnfold = streamReadBool(streamId);
	self.setDown = streamReadBool(streamId);
	self.setTurnedOn = streamReadBool(streamId);
	self.setSwathOn = streamReadBool(streamId);
    self:run(connection);
end;

function SetMowerOptionsEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.setUnfold);
	streamWriteBool(streamId, self.setDown);
	streamWriteBool(streamId, self.setTurnedOn);
	streamWriteBool(streamId, self.setSwathOn);
end;

function SetMowerOptionsEvent:run(connection)
	self.object:setMowerOptions(self.setUnfold, self.setDown, self.setTurnedOn, self.setSwathOn, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetMowerOptionsEvent:new(self.object, self.setUnfold, self.Down, self.setTurnedOn, self.setSwathOn), nil, connection, self.object);
	end;
end;

function SetMowerOptionsEvent.sendEvent(vehicle, setUnfold, setDown, setTurnedOn, setSwathOn, noEventSend)
	--if vehicle.setUnfold ~= setUnfold and
		--vehicle.setDown ~= setDown and
		--vehicle.setTurnedOn ~= setTurnedOn and
		--vehicle.setSwathOn ~= setSwathOn
		--then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(SetMowerOptionsEvent:new(vehicle, setUnfold, setDown, setTurnedOn, setSwathOn), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(SetMowerOptionsEvent:new(vehicle, setUnfold, setDown, setTurnedOn, setSwathOn));
			end;
		end;
	--end;
end;

